package com.sa.ibiz.demo.demo.service.impl;

import java.util.List;
import javax.annotation.Resource;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.mapper.UserRoleDatasMapper;
import com.sa.ibiz.demo.demo.domain.UserRoleDatas;
import com.sa.ibiz.demo.demo.service.UserRoleDatasService;
import com.sa.ibiz.demo.ibizutil.service.ServiceImplBase;
import com.sa.ibiz.demo.demo.service.dto.UserRoleDatasSearchFilter;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import java.util.TreeMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import java.lang.reflect.Field;

import com.sa.ibiz.demo.demo.service.UserRoleDataService;
import com.sa.ibiz.demo.demo.service.UserRoleService;

/**
 * 实体[UserRoleDatas] 服务对象接口实现
 */
@Service
public class UserRoleDatasServiceImpl extends ServiceImplBase<UserRoleDatasMapper, UserRoleDatas> implements UserRoleDatasService{

    @Autowired
    private UserRoleDataService userroledataService;
    @Autowired
    private UserRoleService userroleService;

    @Resource
    private UserRoleDatasMapper userroledatasMapper;


    @Override
    public boolean create(UserRoleDatas et) {
        this.beforeCreate(et);
        String primaryKey=et.getUserroledatasid();
        if(StringUtils.isEmpty(primaryKey))
        {
            primaryKey=(String)et.getDefaultPrimaryKey();
            et.setUserroledatasid(primaryKey);
         }
         return super.create(et);
    }
    @Override
	public UserRoleDatas get(UserRoleDatas et) {
        String primaryKey=et.getUserroledatasid();
         if(StringUtils.isEmpty(primaryKey))
         {
             primaryKey=(String)et.getDefaultPrimaryKey();
             et.setUserroledatasid(primaryKey);
          }
		      return super.get(et);
	}

    @Override
   	public boolean remove(UserRoleDatas et) {
        String primaryKey=et.getUserroledatasid();
         if(StringUtils.isEmpty(primaryKey))
         {
             primaryKey=(String)et.getDefaultPrimaryKey();
             et.setUserroledatasid(primaryKey);
          }
   		     return super.remove(et);
   	}

    @Override
    public boolean update(UserRoleDatas et){
        String primaryKey=et.getUserroledatasid();
         if(StringUtils.isEmpty(primaryKey))
         {
             primaryKey=(String)et.getDefaultPrimaryKey();
             et.setUserroledatasid(primaryKey);
          }
		     this.userroledatasMapper.updateOne(et);
		     this.get(et);
             return true;
    }


    public Object getEntityKey(UserRoleDatas et){
		return et.getUserroledatasid();  
    }

    @Override
    public boolean getDraft(UserRoleDatas et)  {
    if((!StringUtils.isEmpty(et.getUserroledataid())) && et.getUserroledata() == null){
            try {
                et.setUserroledata(userroledataService.getById(et.getUserroledataid()));
            }catch (Exception ex){}
        }
    if((!StringUtils.isEmpty(et.getUserroleid())) && et.getUserrole() == null){
            try {
                et.setUserrole(userroleService.getById(et.getUserroleid()));
            }catch (Exception ex){}
        }
            return true;
    }

	public List<UserRoleDatas> listDefault(UserRoleDatasSearchFilter filter) {
		return userroledatasMapper.searchDefault(filter,filter.getSelectCond());
	}

	public Page<UserRoleDatas> searchDefault(UserRoleDatasSearchFilter filter) {
		return userroledatasMapper.searchDefault(filter.getPage(),filter,filter.getSelectCond());
	}

    public  List<Map<String,Object>> selectRow(String sql){
       return userroledatasMapper.selectRow(sql);
    }

 }